
C Version "%W% %P% %G% %U%
C.........................................................................
C Version "%W% %P% %G% %U%"
C MCPL output module for MM5.  Copyright (C) 1999 MCNC
C Distributed under the GNU LESSER GENERAL PUBLIC LICENSE version 2.1
C See file "LGPL.txt" for conditions of use.
C.........................................................................

        SUBROUTINE  MM2INT( FACTOR, IM, JM, KM, AM,
     &                     NCOLS, NROWS, NLAYS, 
     &                     COL0, ROW0, LAY0, IOUT )

C***********************************************************************
C  subroutine body starts at line  59
C
C  FUNCTION:  Extract/reorder/convert the sub-array specified in 
C	terms of grid-window bounds to I/O API order from array 
C	AM, which is found in standard MM5 subscript order, using
C	FACTOR for units-conversion.
C
C  NOTE that MM5-order I subscripts go from south to north, J subscripts
C	go from west to east, and K subscripts go from top to bottom,
C	whereas IOAPI-order C subscripts go from west to east,
C	R subscripts go from south to north, and L subscripts go
C	from bottom to top.
C
C  PRECONDITIONS REQUIRED:
C	ioapi grid fits within the MM5 grid
C
C  SUBROUTINES AND FUNCTIONS CALLED: none
C
C  REVISION  HISTORY:
C	Prototype OCT. 16, 1997 by Carlie J. Coats, Jr., MCNC
C
C***********************************************************************

      IMPLICIT NONE

C...........   ARGUMENTS and their descriptions:

        REAL		FACTOR  !  conversion factor
        INTEGER		IM	!  I (north-south) dimension for AM
        INTEGER		JM	!  J (east-west)   dimension for AM
        INTEGER		KM	!  K (top-bottom)  dimension for AM
        REAL		AM( IM, JM, KM )	!  MM5-order input array
        INTEGER         NCOLS	!  output dimension
        INTEGER         NROWS	!  " 
        INTEGER         NLAYS	!  "
        INTEGER         COL0	!  starting subscript for output window
        INTEGER         ROW0	!  "
        INTEGER         LAY0	!  "
	INTEGER      	IOUT( NCOLS, NROWS, NLAYS )

C...........   SCRATCH LOCAL VARIABLES and their descriptions:

	INTEGER		C			!  IOAPI col subscript
	INTEGER		R			!  IOAPI row subscript
	INTEGER		L			!  IOAPI lay subscript
	INTEGER		I, J, K 		!  MM5 subscripts
	INTEGER		I0, J0, K0 		!  MM5 offsets

C***********************************************************************
C   begin body of subroutine  MM2INT

        I0 = ROW0 - 1			!  offsets for IOAPI grid within MM5
        J0 = COL0 - 1
        K0 = KM - LAY0 + 2

        DO  33  L = 1, NLAYS
            K = K0 - L
            DO  22  R = 1, NROWS
                I = I0 + R
                DO  11  C = 1, NCOLS
                    J = J0 + C
                    IOUT( C,R,L ) = NINT( FACTOR * AM( I, J, K ) )
11              CONTINUE
22          CONTINUE
33      CONTINUE

        RETURN
        END

